// exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "example.h"
#include "exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg dialog

CExampleDlg::CExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExampleDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CExampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg message handlers

BOOL CExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}
/////////////////////////////////////////////////////////////////////////////
BOOL CExampleDlg::LoadXpsCvtDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"xpscvt.dll");	

	m_hinstLib = LoadLibrary(path);
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pMBegin = (MBegin *)GetProcAddress(m_hinstLib, "MBegin");
	if( pMBegin == NULL ){ 
		FreeXpsCvtDll(); 
		return FALSE;
	}
	pMConvertToImage = (MConvertToImage *)GetProcAddress(m_hinstLib, "MConvertToImage");
	if( pMConvertToImage == NULL ){ 
		FreeXpsCvtDll(); 
		return FALSE;
	}
	pMSetImageParam = (MSetImageParam *)GetProcAddress(m_hinstLib, "MSetImageParam");
	if( pMSetImageParam == NULL ){ 
		FreeXpsCvtDll(); 
		return FALSE;
	}
	pMConvertToPDF = (MConvertToPDF *)GetProcAddress(m_hinstLib, "MConvertToPDF");
	if( pMConvertToPDF == NULL ){ 
		FreeXpsCvtDll(); 
		return FALSE;
	}
	pMPDFEncrypt = (MPDFEncrypt *)GetProcAddress(m_hinstLib, "MPDFEncrypt");
	if( pMPDFEncrypt == NULL ){ 
		FreeXpsCvtDll(); 
		return FALSE;
	}
	pMPDFInformation = (MPDFInformation *)GetProcAddress(m_hinstLib, "MPDFInformation");
	if( pMPDFInformation == NULL ){ 
		FreeXpsCvtDll(); 
		return FALSE;
	}
	pMPDFWatermark = (MPDFWatermark *)GetProcAddress(m_hinstLib, "MPDFWatermark");
	if( pMPDFWatermark == NULL ){ 
		FreeXpsCvtDll(); 
		return FALSE;
	}
	pMConvertToPS = (MConvertToPS *)GetProcAddress(m_hinstLib, "MConvertToPS");
	if( pMConvertToPS == NULL ){ 
		FreeXpsCvtDll(); 
		return FALSE;
	}
	pMEnd = (MEnd *)GetProcAddress(m_hinstLib, "MEnd");
	if( pMEnd == NULL ){ 
		FreeXpsCvtDll(); 
		return FALSE;
	}

	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
BOOL CExampleDlg::FreeXpsCvtDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}
	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnButton1() 
{
	if( LoadXpsCvtDll() == FALSE ){
		MessageBox("Load xpscvt.dll failed!");
		return;
	}

	char infile[256],outpath[256];
	GetModulePath(infile,"test.xps");
	GetModulePath(outpath,"outpath\\");	

	long id = pMBegin();
	if(id>0){
		long imagetype = IMAGE_FORMAT_TIF;
		long bitcount = BITCOUNT_24;
		long quality = 75;
		long rotate = 0;
		long width = 0;
		long height = 0;
		long xdpi = 150;
		long ydpi = 150;

		long compression = COMPRESSION_LZW;
		long multipage = 1;

		//Set Output image param
		pMSetImageParam( id,imagetype,bitcount,quality,rotate,width,height,xdpi,ydpi,compression,multipage);

		//Convert to tiff file (multiple page)
		pMConvertToImage(id,infile,outpath,"multiple");
		pMEnd(id);
	}	

	FreeXpsCvtDll();
	MessageBox("Convert finished!");
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnButton2() 
{
	if( LoadXpsCvtDll() == FALSE ){
		MessageBox("Load xpscvt.dll failed!");
		return;
	}

	char infile[256],outpath[256];
	GetModulePath(infile,"test.xps");
	GetModulePath(outpath,"outpath\\");	

	long id = pMBegin();
	if(id>0){
		long imagetype = IMAGE_FORMAT_JPG;
		long bitcount = BITCOUNT_8G;//256 color grayscale( 8 bits )
		long quality = 85;
		long rotate = 90;
		long width = 1000;
		long height = 800;
		long xdpi = 200;
		long ydpi = 200;
		//only for tiff
		long compression = 0;
		long multipage = 0;

		//Set Output image param
		pMSetImageParam( id,imagetype,bitcount,quality,rotate,width,height,xdpi,ydpi,compression,multipage);

		//Convert to jpg file
		pMConvertToImage(id,infile,outpath,"jpg");
		pMEnd(id);
	}

	FreeXpsCvtDll();
	MessageBox("Convert finished!");
}

void CExampleDlg::OnButton3() 
{
	if( LoadXpsCvtDll() == FALSE ){
		MessageBox("Load xpscvt.dll failed!");
		return;
	}

	char infile[256],outfile[256];
	GetModulePath(infile,"test.xps");
	GetModulePath(outfile,"output.pdf");	

	long id = pMBegin();
	if(id>0){
		long fsize=16;
		long fcolor=255;//red
		long position=2;//Top-Center
		long angle=0;
		long xoff=0;
		long yoff=0;
		long background=1;
		//Stamping
		pMPDFWatermark(id,"Watermark",fsize,fcolor,position,angle,xoff,yoff,background);

		long level = 40;
		long printing = 1;
		long copying = 1;
		long changing = 0;
		long adding = 0;
		//Set PDF Encrypt
		pMPDFEncrypt(id,"password","password2",level,printing,copying,changing,adding);

		//Set PDF Information
		pMPDFInformation(id,"title","subject","author","keywords","creator","producer");

		pMConvertToPDF(id,infile,outfile);
		pMEnd(id);
	}

	FreeXpsCvtDll();
	MessageBox("Convert finished!");	
}

void CExampleDlg::OnButton4() 
{
	if( LoadXpsCvtDll() == FALSE ){
		MessageBox("Load xpscvt.dll failed!");
		return;
	}

	char infile[256],outfile[256];
	GetModulePath(infile,"test.xps");
	GetModulePath(outfile,"output.ps");	
	long id = pMBegin();
	if(id>0){
		long width = 0;
		long height = 0;
		long expand = 0;
		long shrink = 1;
		long center = 1;
		long duplex = 0;
		pMConvertToPS(id,infile,outfile,M_LEVEL2,"A4",width,height,expand,shrink,center,duplex);

		pMEnd(id);
	}

	FreeXpsCvtDll();
	MessageBox("Convert finished!");	
}
